
#ifndef __FLAKE_RULE_H
#define __FLAKE_RULE_H


#include "../lsystem/Rule.h"
#include "../util/Pool.h"
#include "Spike.h"
#include <vector>

class CRandom;


class CSpikeModifier {
public:
	CSpikeModifier( int category, float rx, float ry, float rz, float len, float off, bool random = false )
		: mCategory( category ), mRotX(rx), mRotY(ry), mRotZ(rz), mLenScale(len), mOriginOffset(off), mRandom(random) { }

	void apply( const CSpike& spike, CPool<CSpike>* pools ) const;

private:
	bool	mRandom;
	int		mCategory;
	float	mRotX, mRotY, mRotZ;
	float	mLenScale;
	float	mOriginOffset;

	static CRandom	mRand;
};



class CSpikeRule : public CBaseRule<CSpike> {
public:
	typedef std::vector<CSpikeModifier>	TModifierVector;
public:
	CSpikeRule( float prob ) : CBaseRule<CSpike>(prob) { };

	void addModifier( const CSpikeModifier& mod ) { mModifiers.push_back( mod ); }

	void apply( const CSpike& spike, int vars, CPool<CSpike>* pools ) const;

private:
	TModifierVector	mModifiers;
};


#endif
