
#include <cmath>
#include "Random.h"

//------------------------------------------------------------------------
// CRandom

void CRandom::seed( int ij, int kl )
{
	int i, j, k, l, ii, jj, m;
	double s, t;

	ij %= MAX_IJ;
	kl %= MAX_KL;

	i = (ij / 177) % 177 + 2;
	j = ij % 177 + 2;
	k = (kl / 169) % 178 + 1;
	l = kl % 169;
	for( ii = 1; ii < TABLE_SIZE; ii++ ) {
		s = 0.0;
		t = 0.5;
		for( jj = 1; jj <= 24; jj++ ) {
			m = (((i * j) % 179) * k) % 179;
			i = j;
			j = k;
			k = m;
			l = (53 * l + 1) % 169;
			if( (l * m) % 64 >= 32 )
				s += t;
			t *= 0.5;
		}
		mTable[ii] = (int)(s * RAN_COEF);
	}
	mC	= (int)(  362436.0 / 16777216.0 * RAN_COEF);
	mCD = (int)( 7654321.0 / 16777216.0 * RAN_COEF);
	mCM = (int)(16777213.0 / 16777216.0 * RAN_COEF);
	mI = TABLE_SIZE-1;
	mJ = 33;
}


