
#include "TimeChecker.h"


CTimeChecker::CTimeChecker( double allowedSeconds )
{
	LARGE_INTEGER freq;
	QueryPerformanceFrequency( &freq );
	mClockFreq = (double)freq.QuadPart;
	
	mStartTime = mCurrentTime = getTimer();
	mRealEndTime = mEndTime = mStartTime + allowedSeconds;
}

double CTimeChecker::elapsed()
{
	double ct = getTimer();
	double e = ct - mCurrentTime;
	mCurrentTime = ct;
	return e; 
}

double CTimeChecker::getTimer() const
{
	LARGE_INTEGER t;
	QueryPerformanceCounter( &t );
	return (double)t.QuadPart / mClockFreq;
}

